/* cueCat
 * 
 *
 * Sketch by Damien Holloway - 6 July 2012
 * 
 */
#include <LiquidCrystal.h> 
#include <PS2Keyboard.h>

String projectName = "CueCat";
String projectVersion = "V12 by Damien";
// probe pins
#define dataPin        8         // Data pin 1 on PS2 connector
#define clockPin       3         // Data Pin 5 on PS2 Connector
#define buzzerPin      11         // Buzzer +ve Pin
#define ledPin         13         // built in LED
/* -----------------------------*/
// Create instances of Hardware variables
LiquidCrystal lcd(8,9,4,5,6,7);
//#define LCD_BACKLIGHT_PIN         3  // D3 controls LCD backlight 
// LCD vars
#define topRow 0
#define btmRow 1

#define FALSE  0
#define TRUE   1
#define DEBUG  2
String ASCII =     " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"; // bits of the ASCII table relevant, add 46 to index... note the \\ is a delimited '\'. pos 34 \" is delimited "
//                  23 4567890123456789012345678901234567890123456789012345678901 23456789012345678901234567890123456
//                3          4         5         6         7         8         9          0         1         2    

String reference = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-"; //the leading '.' avoids having to add 1 to any index values looked up
//                  012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
//     1         2         3         4         5         6         7         8        

String encryptedString = "";

PS2Keyboard keyboard;

void setup() { 

  LCDInit();
 // pinMode(dataPin, INPUT);  // data pin for cuecat                                             
 // pinMode(clockPin, INPUT); // clock pin for cuecat
 // pinMode(ledPin, OUTPUT);
  //keyboard.begin(DataPin, IRQpin, PS2Keymap_US);
  keyboard.begin(dataPin, clockPin, PS2Keymap_German);
  
  tone(buzzerPin,2000,100);
  delay(30);
  tone(buzzerPin,2500,100);
  
  Serial.println("Scan like a Sir... ");
} 

void loop() { 
  //byte dataValue = dataRead();
  //LSwrite("found",1); 
  //Serial.println(dataValue);
  
  //encryptedString = readCueCat();
  //analyzeInput(encryptedString);
 if (keyboard.available()) {
    int   c = keyboard.read();
    //Serial.print(c);
    //Serial.print("->");
    //Serial.println(charASCII(c));
    if(c==13){ // end of line
      tone(buzzerPin,2500,50);
      delay(60);
      tone(buzzerPin,3000,100);
      //Serial.println(encryptedString);
      analyzeInput(encryptedString);
      Serial.println();
      encryptedString  = "";
    }else{
     //Serial.print(c);
     //Serial.print("->");
     //Serial.println(charASCII(c));
      encryptedString += charASCII(c);
    }
  }

} //end loop

String readCueCat(){
    
  //Serial.println("Waiting like a boss... ");
  //while(!keyboard.available()){};

  //int   c = keyboard.read();
  //Serial.print(c);
  //Serial.print("->");
  //Serial.println((char)c);
 

  
} //end readCueCat


void analyzeInput(String input){
  // take input and break into 3 components delimited by '.'
  int length = input.length();
  //LSwrite(floatToString(length,0),1); 

  String myString = input;
  int i = 0;                                                         // the starting position for the search
  int prev_i;                                                        // keep track of previous search  
  if (DEBUG >= 4){ Serial.print("Starting loop -> ");  Serial.println(myString);}
  
  prev_i = 1;
  
  // while there are string delimited by '.' unencrypt each part
  while(((i = myString.indexOf('.',i+1))>=0)){                         // expect to run thsi 3 times ID, CODE TYPE, BARCODE
    String foundString = myString.substring(prev_i,i);                 // take the string dellimited by the next '.' and previous '.'
    if (DEBUG >= 4){ Serial.print("Decrypting: " + foundString); }
    String output = decrypt(foundString);                              // unencrypt it
    if (DEBUG >= 4){ Serial.println(" -> (" + output + ")"); }
    Serial.print(output + ",");
    prev_i = i+1; //as I don't need the '.' at start of the string     // remember the starting point for the next encrypted string.

  } 
  if (DEBUG >= 4){ Serial.println("Done ALL 3  parts of this input: ");}
} // end analyzeInput 

int codeASCII (char chr){ // given a character, return the ASCII code in DEC format
  int index;
  index = ASCII.indexOf(chr);
  index += 32; // add 32 for the array offset, (ie the ASCII array first character is ASCII 32, ie SPACE.)
  if (DEBUG >= 7){ Serial.println("codeASCII: (index) chr = (" + String(index) + ") " + chr);  }
  return index;
}

char charASCII(int index){// given an ASCII value, return the ASCII Character
  char chr;
  index = index - 32; // subtract 32 for the array offset, (ie the ASCII array first character is ASCII 32, ie SPACE.)
  chr = ASCII.charAt(index);
  if (DEBUG >= 10){ 
    Serial.println("charASCII: (index) chr = (" + String(index) + ") " + chr);
  }
  return chr;
}

int transposeChar(char chr){ // performs the translation table function
  int index = reference.indexOf(chr);
  index += 32; // add 32 for ASCII offset
  return index;
} //end transposeChar

String decrypt(String input){
  int inputLength = input.length();            // The length of the encrpted string, we will use this to track precessing           
  int outputLength = (int)(inputLength *3/4);  // the length of the final output. Each character will represent 6 bits and converted into 8 bit characters, so there will be 6/8 = 3/4 as many characters
                                               // cast to (int) to round down the number
  
  if (DEBUG >= 10){ Serial.println("lengths: (input/output) chr = (" + String(inputLength) + "/" + String(outputLength) + ")");  }

  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  if (DEBUG >= 1){ 
    // I have no idea why this is needed, I had a similar line here used for debug, and it stopped working when I removed it. 
    // I trouble shot for a while to try and find if there was some change to existing variables, which is not the case...
    // just need to have a String() function called. And it needs to be in If statement... I am baffled
    String junk = String(13);
  }
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
  //arrays are 0 indexed, so subtract 1
  inputLength --;
  outputLength --;

  // build an array of ASCII codes, avoid converting back and fords, else can't debug easily as some characters ar not printable, and in any case it is not useful
  int inputArray[inputLength];
  int outputArray[outputLength];
  String output = ""; //initiaize an empy string for the final output, this is the var that will be returned

  // transpose the input array, and store the index value... subtract 32...
  for(int i=0;i<=inputLength;i++){
    inputArray[i] = (transposeChar(input.charAt(i))-32); // could have written the transposeChar function to -32, but makes it easier to understand and debug I think
    if (DEBUG >= 4){ 
      Serial.println("Transposing: Input " + String(i) + " = (" + String(input.charAt(i)) + "," + String(codeASCII(input.charAt(i))) + ")->(" + String(inputArray[i]) + "," + String(charASCII(inputArray[i]+32)) + ") ");
    }
  }

  ////////////////////////////////////////
  // now take the input array (6 bit Values) and turn into 8 bit output values
  
  int k=0; // k tracks every 8 bits
  outputArray[k] = 0; // initialize the output array entry that will hold the ASCII code for the final output. Will need to do this before each entry in the array is used.
  int outputIndex = 0; // track which outputArray entry I am using now, remember, there is one for every 8 bits 
  
  for(int i=0;i<=inputLength;i++){ // for each input character
    for(int j=0;j<=5;j++){         // read in 6 bits
      int shiftedBit = (inputArray[i] >> (5-j)) & 1; // each loop of j processes 1 of the 6 bits, extracting the value, either 0 or 1
      
      outputArray[outputIndex] = outputArray[outputIndex]*2 + shiftedBit; // shifting left in binary is same as multiplying by 2, I am assuming there are no values above 63, which should be valid...
      
      if (DEBUG >= 7){ Serial.println("(i,j,k) Out = (" + String(i) + ", " + String(j) + ", " + String(k) + ")" + String(outputArray[outputIndex]));  }
      
      k++;
      if(k>7){ // filled 8 bits, process as a char, and move to next 8 bit character in the output...
        // this involves XOR with 67 and converting back to ASCII
        if (DEBUG >= 6){ Serial.print("Final OutValue= " + String(outputArray[outputIndex]) + ", " + charASCII(outputArray[outputIndex])); }

        //XOR the value with 67
        outputArray[outputIndex] ^= 67;
        
        if (DEBUG >= 6){ Serial.println(" XOR = " + String(outputArray[outputIndex]) + ", " + charASCII(outputArray[outputIndex])); }
        
        output = output + charASCII(outputArray[outputIndex]); // convert to ASCII and conatenate to output
        k = 0;                                                 // reset counter for next 8 bits
        outputIndex++;                                         // move to the next output character // could I do this with mod and div functions?

        if (outputIndex > outputLength){ // we have calculated the last output character, there may be a few final bits of input, but they can be ignored, so break out of the loop...
          if (DEBUG >= 7){ Serial.println("BREAK: outputLength exceeded");}
          break; 
        }
        outputArray[outputIndex] = 0; //initialize the next array entry
      }//end if (k>7)

    }// end for j

  }// end for i

  return output;
} //end decrypt


//---------------------------------------------------------------------------------
// Damien's Code
//

String floatToString (float number){
  //  #include <stdlib.h> for this to work

  int digits = 0;
  char theString[32];
  int decimalPoints = 0;
  dtostrf(number,digits,decimalPoints,theString);
  return String(theString);

}


//---------------------------------------------------------------------------------
// Damien's Code - Generic
//

//
void LCDInit()
{
  lcd.begin(16, 2);
  // start with the project name and version 
  Serial.begin(115200);

  lcd.print(projectName);
  Serial.println(projectName); 
  lcd.setCursor(0,1);  //col, row
  lcd.print(projectVersion);
  Serial.println(projectVersion); 
  delay(1000);


}

void LCDWrite(String text, int row)
{
  //lcd.setCursor(0,row);  //col, row
  //lcd.print ("                "); //16 Spaces to clear the row
  // Assume we are writing the whoel row, and blank out unwrttien rowsss
  lcd.setCursor(0,row);  //col, row
  lcd.print(text+"                "); //the spaces make sure the whole row is written over...
}

void LSwrite(String text, int row)
{
  String tmp = text;
  LCDWrite(tmp,row);
  Serial.println(tmp); 
}

//
//




